﻿Imports System.Text
Imports System.IO

Public Class TSharkTray

    Dim FlagMonitoring As Integer 'モニタリングの状態フラグ
    Dim psi As New System.Diagnostics.ProcessStartInfo() 'TSharkプロセス関連
    Dim p As System.Diagnostics.Process 'TSharkプロセス関連

    'INIファイル読み込み関連
    Private Declare Function GetPrivateProfileString Lib "KERNEL32.DLL" _
        Alias "GetPrivateProfileStringA" (
            ByVal lpApplicationName As String,
            ByVal lpKeyName As String,
            ByVal lpDefault As String,
            ByVal lpReturnedString As StringBuilder, ByVal nSize As Integer,
            ByVal lpFileName As String
    ) As Integer

    Private Declare Function WritePrivateProfileString Lib "KERNEL32.DLL" _
        Alias "WritePrivateProfileStringA" (
            ByVal lpApplicationName As String,
            ByVal lpKeyName As String,
            ByVal lpString As String,
            ByVal lpFileName As String
    ) As Integer

    'INIファイル読み込み関連
    Private Function GetIniFileValue(ByVal IniAppName As String, ByVal IniKeyName As String, ByVal IniDefValue As String) As String

        Dim IniValue As StringBuilder = New StringBuilder(256)
        Dim i As Long

        i = GetPrivateProfileString(IniAppName, _
                                    IniKeyName, _
                                    IniDefValue, _
                                    IniValue, _
                                    200, _
                                    System.IO.Directory.GetCurrentDirectory & "\TSharkTray.ini" _
                                    )

        GetIniFileValue = Trim$(IniValue.ToString())

    End Function

    Private Function WriteIniFileValue(ByVal IniAppName As String, ByVal IniKeyName As String, ByVal IniValue As String) As String

        Dim i As Long

        i = WritePrivateProfileString(IniAppName,
                                    IniKeyName,
                                    IniValue,
                                    Directory.GetCurrentDirectory & "\TSharkTray.ini"
                                    )

        WriteIniFileValue = Trim$(IniValue.ToString())

    End Function

    'TSharkTrayを終了
    Private Sub TSharkTray_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed

        Call ExecStopTShark()

    End Sub

    'TSharkTrayを開始
    Private Sub TSharkTray_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load

        Timer1.Interval = CInt(GetIniFileValue("TSharkTray", "INTERVAL", "1")) * 60000

        Call ExecStartTshark()
        Call ExecDeleteLog()

        Timer1.Enabled = True
        Timer2.Enabled = True
        Timer3.Enabled = True
        Timer4.Enabled = True

    End Sub

    'タスクトレイ関連の動作
    Private Sub NotifyIcon1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick

        With Me
            If .WindowState = FormWindowState.Minimized Then
                .WindowState = FormWindowState.Normal

                .Left = System.Windows.Forms.Screen.PrimaryScreen.WorkingArea.Width - .Width
                .Top = System.Windows.Forms.Screen.PrimaryScreen.WorkingArea.Height - .Height

                .ShowInTaskbar = True
                .Visible = True
                .Activate()
            Else
                .ShowInTaskbar = False
                .Visible = False

                .WindowState = FormWindowState.Minimized
            End If
        End With

    End Sub

    '最小化ボタン
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        With Me
            .ShowInTaskbar = False
            .Visible = False

            .WindowState = FormWindowState.Minimized
        End With

    End Sub

    '終了ボタン
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        If MsgBox("TSharkTrayを終了しますか？", vbOKCancel + vbDefaultButton2, "TSharkTray") = vbOK Then
            Me.Close()
        End If

    End Sub

    'TSharkの起動
    Private Sub ExecStartTshark()

        Dim OptionFilter As String
        Dim OptionInterface As String
        Dim OptionExePath As String
        Dim OptionDate As String
        Dim OptionLogDir As String
        Dim OptionSwitches As String

        FlagMonitoring = False

        OptionDate = Now.ToString("yyyyMMdd")

        If System.IO.Directory.Exists(GetIniFileValue("TSharkTray", "LOGDIR", "C:\TEMP\")) = False Then
            NotifyIcon1.Visible = False

            MsgBox("設定されているログフォルダが存在しません。設定(LOGDIR)を確認してください。", vbOKOnly, "TSharkTray")
            End
        End If

        OptionLogDir = GetIniFileValue("TSharkTray", "LOGDIR", "C:\TEMP\")

        If System.IO.File.Exists(GetIniFileValue("TSharkTray", "PATH", "C:\Program Files\Wireshark\tshark.exe")) = False Then
            NotifyIcon1.Visible = False

            MsgBox("設定パスにtshark.exeが存在しません。設定(PATH)を確認してください。", vbOKOnly, "TSharkTray")
            End
        End If

        OptionExePath = """" & GetIniFileValue("TSharkTray", "PATH", "C:\Program Files\Wireshark\tshark.exe") & """"

        OptionFilter = """" & GetIniFileValue("TSharkTray", "FILTER", "") & """"

        OptionInterface = """" & GetIniFileValue("TSharkTray", "INTERFACE", "") & """"

        OptionSwitches = "-i " & OptionInterface _
                        & " -f " & OptionFilter _
                        & " -w " & OptionLogDir & "\TSharkTray_" & OptionDate & ".pcap"

        psi.FileName = OptionExePath
        psi.Arguments = OptionSwitches
        psi.UseShellExecute = False
        psi.CreateNoWindow = True

        p = System.Diagnostics.Process.Start(psi)

        FlagMonitoring = True

    End Sub

    'TSharkの終了
    Private Sub ExecStopTShark()

        If FlagMonitoring = True Then
            If p.HasExited() = False Then
                FlagMonitoring = False

                p.Kill()

                p.Close()
                p.Dispose()
                p = Nothing
            End If
        End If

    End Sub

    'TSharkの再起動タイマー
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Timer1.Enabled = False

        Call ExecStopTShark()

        Call ExecStartTshark()

        Timer1.Enabled = True

    End Sub

    'TSharkの生存確認タイマー
    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick

        Timer2.Enabled = False

        If FlagMonitoring = True Then
            If p.HasExited() = True Then
                FlagMonitoring = False
                NotifyIcon1.Visible = False

                p.Close()
                p.Dispose()
                p = Nothing

                End
            End If
        End If

        Timer2.Enabled = True

    End Sub

    '何となく入れてみたGCタイマー
    Private Sub Timer3_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer3.Tick

        Timer3.Enabled = False

        GC.Collect()

        Timer3.Enabled = True

    End Sub

    Private Sub Timer4_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer4.Tick

        Timer4.Enabled = False

        Call ExecDeleteLog()

        Timer4.Enabled = True

    End Sub

    Private Sub ExecDeleteLog()

        Dim SystemDate As DateTime = DateTime.Parse(Now.ToString("yyyy/MM/dd"))

        Dim OptionLogDay As Integer
        Dim OptionLogDir As String

        Dim RemoveDate As Integer
        Dim FileList As String() 'フォルダリスト
        Dim FileDate As Integer
        Dim i As Long 'ループカウンタ

        OptionLogDay = CInt(GetIniFileValue("TSharkTray", "LOGDAY", "30"))
        OptionLogDir = GetIniFileValue("TSharkTray", "LOGDIR", "C:\TEMP\")

        'INIファイルの設定から削除の日付起点を取得する
        RemoveDate = CInt(SystemDate.AddDays((OptionLogDay) * -1).ToString("yyyyMMdd"))

        'ログフォルダからフォルダの一覧を配列に取得する(削除しないフォルダも含む)
        FileList = Directory.GetFiles(OptionLogDir, "TSharkTray_????????.pcap")

        If FileList.Count <> 0 Then
            'ファイルの分だけ繰り返す
            For i = 0 To FileList.Count - 1

                FileDate = CInt(Strings.Mid(Path.GetFileName(FileList.GetValue(i).ToString), 12, 8))

                If RemoveDate > FileDate Then
                    File.Delete(FileList.GetValue(i).ToString)
                End If
            Next

        End If

    End Sub
End Class